using System;
using System.Configuration;
using System.Collections;

using Seva.ApplicationLogs; 
using Seva.Programm;

namespace MsmqApplication
{
    public class ProgrammConfig
    {
        //     private const String MsmqSection = "MsmqQueues";
        private const String ResponseQueueSetting = "ResponseQueue"; 
        private const String OrderQueueSetting = "OrderQueue"; 
        private const String    FunctionsFileSetting = "FunctionsFile";
        
        public static readonly String ResponseQueueName; 
        public static readonly String OrderQueueName; 
        public static readonly String FunctionsFileName;    
            
        static String NotNullSetting(String setting)
        {
            
            
            String value = value = ConfigurationManager.AppSettings[setting];               
                
            //if (value==null) Log.Error(Messages.configError1, setting);               
            
            return value;
        }
        
        static void ShowConfig()
        {
            System.Collections.Specialized.NameValueCollection appSettings = ConfigurationManager.AppSettings;
            Log.Message(Messages.configConfiguration);
            if (appSettings.Keys.Count==0)
                Log.Message(Messages.configEmpty);          
            else
                foreach(String key in appSettings.Keys)
                    Log.Message(Messages.configKeys,  key,  appSettings[key]);          
        }
        
        static ProgrammConfig()
        {
            ShowConfig();
                    
            Log.Start(Messages.configApplySettings);
            ResponseQueueName = NotNullSetting(ResponseQueueSetting);
            OrderQueueName = NotNullSetting(OrderQueueSetting);
            FunctionsFileName = NotNullSetting(FunctionsFileSetting);
            Log.Finish();
                
            /*        Configuration config =        ConfigurationManager.OpenExeConfiguration(ConfigurationUserLevel.None);*/
      
            /*        CustomSection section = config.Sections[MsmqSection];
            if (section == null)
                {
                Log.Error("Section {0} not found. Cannot continue.", MsmqSection);
                }*/
                
        }
    }   
}