// LcePublisher.cs

using System;
using System.Threading;
using System.Runtime.InteropServices;
using System.EnterpriseServices;

using Seva.ComUtils;

[assembly: ApplicationName("LCE publisher")]
[assembly: ApplicationActivation(ActivationOption.Server)]
[assembly: ApplicationAccessControl(false)]

[EventClass]
[Guid(EventsGuids.EventClassId)]
[Transaction(TransactionOption.Disabled)]
public class LceEvents: ServicedComponent, ILceMessage
{
    public void TriggerEvent(string message)
    {
    }
}

public class LcePublisher: ServicedComponent
{
    public LcePublisher()
    {
    }
    
    public void DoWork()
    {
        ILceMessage lcEvent  = (ILceMessage) new LceEvents();                       
        try
        {    
            while (true)
            {
                lcEvent.TriggerEvent("!");
                Thread.Sleep(1000); 
            }
        }
        catch (System.Runtime.InteropServices.COMException)        
        {
            Console.WriteLine(" ");
        }
    }
}        

class MainApp
{            
    public static void Main()
    {
        LcePublisher com = new LcePublisher();
        com.DoWork();
    }
}

// LcePublisher.cs