using System;

using Seva.Programm;

namespace Seva.ApplicationLogs
{   
    public abstract class Log
    {   
            
        public static void Error(String message) 
        {
            Message(message);
            throw new Exception(message);
        }
        //      
        public static void Message(String message) 
        {
            Console.WriteLine(message);
        }
        //
        public static void Error(String message,  params Object[] objects)
        {
            Error(String.Format(message, objects));
        }
        
        public static void Message(String message, params Object[] objects)
        {
            Message(String.Format(message, objects));
        }
        //
        public static void Start(String message) 
        {
            Console.Write(message+Messages.logStartSuffix);
        }   
        public static void Finish() 
        {
            Console.WriteLine(Messages.logFinish);
        }
        public static void Progress() 
        {
            Console.Write(Messages.logProgress);
        }           
    }   
}   