using System;
using System.IO;
using System.EnterpriseServices;
//using System.EnterpriseServices.CompensatingResourceManager;

using System.Messaging;

using Seva.Msmq;
using Seva.Swc;

/*[assembly: ApplicationActivation(ActivationOption.Server)]
[assembly: ApplicationAccessControl(false)]
[assembly: ApplicationCrmEnabled]*/

/*[Transaction(TransactionOption.RequiresNew)]
public class SampleCrmClient: ServicedComponent
{
    public SampleCrmClient()
    {
    }
    
    public void DoSomeWork()
    {    

        const string fileName = "sample.txt";   

        StreamCrm crm = new StreamCrm();

        Console.WriteLine(" ...");            
        Clerk clerk = StreamCrm.CreateClerk();        

        Console.WriteLine("  ...");
                       
        using (StreamWriter writer = new StreamWriter(crm.WriteToFile(fileName)))
        {            
            writer.Write("   ");
        }                 
                    
        clerk.WriteLogRecord(crm.Flush(fileName));

        Console.WriteLine(" <Enter>   ");
        //Console.ReadLine();

        ContextUtil.SetComplete();
    }
} */   

public class MainApp
{
    public static void Main()
    {
/*        using (SampleCrmClient crm = new SampleCrmClient())
        {
            crm.DoSomeWork();
        }*/
        using (SwcUtil swc = new SwcUtil())
        {
           /* const string fileName = "sample.txt";   

            StreamCrm crm = new StreamCrm();
                
            Console.WriteLine(Environment.CurrentDirectory);
           
            new Clerk(typeof(StreamCompensator), "Compensator",  
                                CompensatorOptions.AllPhases);
            
           Clerk clerk = StreamCrm.CreateClerk();        

            Console.WriteLine(Environment.CurrentDirectory);
                           
            using (StreamWriter writer = new StreamWriter(crm.WriteToFile(fileName)))
            {            
                writer.Write(Environment.CurrentDirectory);
            }                 
                        
            clerk.WriteLogRecord(crm.Flush(fileName));*/
            
            MessageQueue queue = MsmqTools.CreateQueue(@".\Private$\swc_queue");
            
            queue.Send("SWC Message", MessageQueueTransactionType.Automatic);

            Console.WriteLine(" <Enter>   ");
            Console.ReadLine();

            ContextUtil.SetComplete();   
            
        }
    }
}